unit mkposxy1;

interface

uses  //elsat,ixsat,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;
               
type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type Tsatel = record
                 t0  : double;
                 cmx : array [1..6] of single;
                 cfx : array [1..4] of single;
                 cmy : array [1..6] of single;
                 cfy : array [1..4] of single;
     end;
     Tsatix = record
                 idn : array [1..8] of integer;
                 freq : array [1..8] of double;
                 dellt : array [1..8] of double;
                 djori : double;
                 ienrf : integer; // nb. elem.
                 ixa : integer; // debut dans elem.
     end;
     Tinrec = record
                 isat : char;
                 idx :  array[1..3]of char;
                 ldat1: array[1..8]of char;
                 ldat2: array[1..8]of char;
                 t0  : array[1..9]of char;
                 cmx : array [1..6,1..17] of char;
                 cfx : array [1..4,1..17] of char;
                 cmy : array [1..6,1..17] of char;
                 cfy : array [1..4,1..17] of char;
     end;

function words(str,sep : string; p,n : integer) : string;
var     i,j : Integer;
begin
result:='';
str:=trim(str);
for i:=1 to p-1 do begin
 j:=pos(' ',str);
 if j=0 then j:=length(str)+1;
 str:=trim(copy(str,j,length(str)));
end;
for i:=1 to n do begin
 j:=pos(' ',str);
 if j=0 then j:=length(str)+1;
 result:=result+trim(copy(str,1,j))+sep;
 str:=trim(copy(str,j,length(str)));
end;
end;

procedure TForm1.Button1Click(Sender: TObject);
const lrecl = 370;
var lin : array [1..lrecl] of char;
    yy,ipla,n,i,curelm : integer;
    f : file;
    ix : tsatix;
    el : tsatel;
    ixf,elf : textfile;
    outl : string;
    inrec : Tinrec;
    scmx : array [1..6] of string;
    scfx : array [1..4] of string;
    scmy : array [1..6] of string;
    scfy : array [1..4] of string;
const nompla : array [1..4] of string = ('mars','jupiter','saturne','uranus');
      nsat : array [1..4] of integer =(2,4,8,5);
      datedeb=1997; datefin=2020;
begin
assignfile(ixf,'ixsat.pas');
assignfile(elf,'elsat.pas');
rewrite(ixf);
rewrite(elf);
writeln(ixf,'unit ixsat;');
writeln(ixf,'interface');
writeln(ixf,'Type Tsatix = record');
writeln(ixf,'          idn : array [1..8] of integer;');
writeln(ixf,'          freq : array [1..8] of double;');
writeln(ixf,'          dellt : array [1..8] of double;');
writeln(ixf,'          djori : double;');
writeln(ixf,'          ienrf : integer; // nb. elem.');
writeln(ixf,'         ixa : integer; // debut dans elem.');
writeln(ixf,'end;');
writeln(ixf,'const');
writeln(ixf,'ixelem : array[1..4,1..24] of Tsatix = (');
writeln(elf,'unit elsat;');
writeln(elf,'interface');
writeln(elf,'type Tsatel = record');
writeln(elf,'                 t0  : double;');
writeln(elf,'                 cmx : array [1..6] of single;');
writeln(elf,'                 cfx : array [1..4] of single;');
writeln(elf,'                 cmy : array [1..6] of single;');
writeln(elf,'                 cfy : array [1..4] of single;');
writeln(elf,'     end;');
writeln(elf,'const');
writeln(elf,'elem : array[1..6456] of Tsatel = (');
curelm:=0;
for ipla := 1 to 4 do begin
outl:='(';
writeln(ixf,outl);
for yy:=datedeb to datefin do begin
edit1.text:=nompla[ipla]+' '+inttostr(yy);
form1.refresh;
filemode:=0;
Assignfile(f,nompla[ipla]+'.'+inttostr(yy));
reset(f,1);
  blockread(f,lin,lrecl,n);
  for i:=1 to nsat[ipla] do ix.idn[i] := strtoint(words(lin,'',i+2,1));
  for i:=1 to nsat[ipla] do ix.freq[i] := strtofloat(words(lin,'',i+2+nsat[ipla],1));
  for i:=1 to nsat[ipla] do ix.dellt[i] := strtofloat(words(lin,'',i+2+2*nsat[ipla],1));
  ix.ienrf := strtoint(words(lin,'',1+2+3*nsat[ipla],1));
  ix.djori := strtofloat(words(lin,'',2+2+3*nsat[ipla],1));
  ix.ixa :=curelm;
  if nsat[ipla]<8 then for i:=nsat[ipla]+1 to 8 do ix.idn[i] := 0;
  if nsat[ipla]<8 then for i:=nsat[ipla]+1 to 8 do ix.freq[i] := 0;
  if nsat[ipla]<8 then for i:=nsat[ipla]+1 to 8 do ix.dellt[i] := 0;
  outl:='(idn : (';
  for i:=1 to 8 do begin
      outl:=outl+inttostr(ix.idn[i]);
      if i=8 then outl:=outl+'); freq : ('
             else outl:=outl+',';
  end;
  for i:=1 to 8 do begin
      outl:=outl+floattostr(ix.freq[i]);
      if i=8 then outl:=outl+'); dellt : ('
             else outl:=outl+',';
  end;
  for i:=1 to 8 do begin
      outl:=outl+floattostr(ix.dellt[i]);
      if i=8 then outl:=outl+'); '
             else outl:=outl+',';
  end;
  outl:=outl+' djori : '+floattostr(ix.djori)+'; ';
  outl:=outl+' ienrf : '+inttostr(ix.ienrf)+'; ';
  outl:=outl+' ixa : '+inttostr(ix.ixa);
  if yy=datefin then if ipla=4 then outl:=outl+'))'
                               else outl:=outl+')),'
                else outl:=outl+'),';
  writeln(ixf,'// '+edit1.text);
  writeln(ixf,outl);
if ipla=4 then blockread(f,lin,2,n);  // !! deux caracters de plus pour uranus !!
writeln(elf,'// '+edit1.text);
repeat
  inc(curelm);
  blockread(f,lin,lrecl,n);
  move(lin,inrec,sizeof(inrec));
  el.t0 := strtofloat(inrec.t0);
  for i:=1 to 6 do scmx[i] :=StringReplace(inrec.cmx[i],'D','E',[]);
  for i:=1 to 4 do scfx[i] :=StringReplace(inrec.cfx[i],'D','E',[]);
  for i:=1 to 6 do scmy[i] :=StringReplace(inrec.cmy[i],'D','E',[]);
  for i:=1 to 4 do scfy[i] :=StringReplace(inrec.cfy[i],'D','E',[]);
  for i:=1 to 6 do el.cmx[i] :=strtofloat(scmx[i]);
  for i:=1 to 4 do el.cfx[i] :=strtofloat(scfx[i]);
  for i:=1 to 6 do el.cmy[i] :=strtofloat(scmy[i]);
  for i:=1 to 4 do el.cfy[i] :=strtofloat(scfy[i]);
  outl:='( t0 : '+inrec.t0+' ; cmx : (';
  for i:=1 to 6 do begin
      outl:=outl+scmx[i];
      if i=6 then outl:=outl+'); cfx : ('
             else outl:=outl+',';
  end;
  for i:=1 to 4 do begin
      outl:=outl+scfx[i];
      if i=4 then outl:=outl+'); cmy : ('
             else outl:=outl+',';
  end;
  for i:=1 to 6 do begin
      outl:=outl+scmy[i];
      if i=6 then outl:=outl+'); cfy : ('
             else outl:=outl+',';
  end;
  for i:=1 to 4 do begin
      outl:=outl+scfy[i];
      if i=4 then outl:=outl+')'
             else outl:=outl+',';
  end;
  if eof(f) then if (yy=datefin) and (ipla=4) then outl:=outl+'));'
                                              else outl:=outl+'),'
            else outl:=outl+'),';
  writeln(elf,outl);
until eof(f);
closefile(f);
end;
end;
writeln(ixf,');');
writeln(ixf,'implementation');
writeln(ixf,'end.');
writeln(elf,'// replace 6456 ='+inttostr(curelm));
writeln(elf,'implementation');
writeln(elf,'end.');
closefile(ixf);
closefile(elf);
end;

end.
